Index: uspace/lib/nic/src/nic_wol_virtues.c
===================================================================
--- uspace/lib/nic/src/nic_wol_virtues.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/nic/src/nic_wol_virtues.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -38,5 +38,4 @@
 #include "nic_wol_virtues.h"
 #include <assert.h>
-#include <errno.h>
 
 #define NIC_WV_HASH_COUNT 32
Index: uspace/lib/posix/ctype.c
===================================================================
--- uspace/lib/posix/ctype.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/posix/ctype.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -112,5 +112,5 @@
  * @return Non-zero if character match the definition, zero otherwise.
  */
-int posix_isascii(int c)
+extern int posix_isascii(int c)
 {
 	return c >= 0 && c < 128;
@@ -123,5 +123,5 @@
  * @return Coverted character.
  */
-int posix_toascii(int c)
+extern int posix_toascii(int c)
 {
 	return c & 0x7F;
Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/devman/devman.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -794,4 +794,7 @@
 	case EOK:
 		dev->state = DEVICE_USABLE;
+		exch = async_exchange_begin(drv->sess);
+		async_msg_1(exch, DRIVER_DEV_ADDED, dev->handle);
+		async_exchange_end(exch);
 		break;
 	case ENOENT:
@@ -800,5 +803,4 @@
 	default:
 		dev->state = DEVICE_INVALID;
-		break;
 	}
 	
Index: uspace/srv/hid/input/generic/input.c
===================================================================
--- uspace/srv/hid/input/generic/input.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/hid/input/generic/input.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -39,5 +39,4 @@
 #include <adt/list.h>
 #include <bool.h>
-#include <fibril_synch.h>
 #include <ipc/services.h>
 #include <ipc/input.h>
@@ -84,6 +83,4 @@
 async_sess_t *irc_sess = NULL;
 
-static FIBRIL_MUTEX_INITIALIZE(discovery_lock);
-
 void kbd_push_data(kbd_dev_t *kdev, sysarg_t data)
 {
@@ -596,20 +593,12 @@
 	int rc;
 	
-	fibril_mutex_lock(&discovery_lock);
-	
 	rc = dev_check_new_kbdevs();
-	if (rc != EOK) {
-		fibril_mutex_unlock(&discovery_lock);
+	if (rc != EOK)
 		return rc;
-	}
 	
 	rc = dev_check_new_mousedevs();
-	if (rc != EOK) {
-		fibril_mutex_unlock(&discovery_lock);
+	if (rc != EOK)
 		return rc;
-	}
-	
-	fibril_mutex_unlock(&discovery_lock);
-	
+
 	return EOK;
 }
Index: uspace/srv/hid/input/include/sun.h
===================================================================
--- uspace/srv/hid/input/include/sun.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
+++ uspace/srv/hid/input/include/sun.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2009 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbdgen generic
+ * @brief Sun keyboard virtual port driver.
+ * @ingroup kbd
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KBD_SUN_H_
+#define KBD_SUN_H_
+
+extern int ns16550_port_init(void);
+extern int z8530_port_init(void);
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/input/port/dummy.c
===================================================================
--- uspace/srv/hid/input/port/dummy.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
+++ uspace/srv/hid/input/port/dummy.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2009 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_port
+ * @brief	Dummy keyboard port driver.
+ * @ingroup  kbd
+ * @{
+ */ 
+/** @file
+ */
+
+#include <kbd_port.h>
+#include <kbd.h>
+
+int kbd_port_init(void)
+{
+	return 0;
+}
+
+void kbd_port_yield(void)
+{
+}
+
+void kbd_port_reclaim(void)
+{
+}
+
+void kbd_port_write(uint8_t data)
+{
+	(void) data;
+}
+
+/** @}
+*/
Index: uspace/srv/hid/input/port/sgcn.c
===================================================================
--- uspace/srv/hid/input/port/sgcn.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
+++ uspace/srv/hid/input/port/sgcn.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -0,0 +1,188 @@
+/*
+ * Copyright (c) 2008 Pavel Rimsky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_port
+ * @ingroup  kbd
+ * @{
+ */
+/** @file
+ * @brief SGCN (Serengeti Console) keyboard port driver.
+ */
+
+#include <as.h>
+#include <ddi.h>
+#include <async.h>
+#include <kbd.h>
+#include <kbd_port.h>
+#include <sysinfo.h>
+#include <stdio.h>
+#include <thread.h>
+#include <bool.h>
+#include <errno.h>
+
+#define POLL_INTERVAL  10000
+
+/**
+ * SGCN buffer header. It is placed at the very beginning of the SGCN
+ * buffer.
+ */
+typedef struct {
+	/** hard-wired to "CON" */
+	char magic[4];
+	
+	/** we don't need this */
+	char unused[8];
+	
+	/** offset within the SGCN buffer of the input buffer start */
+	uint32_t in_begin;
+	
+	/** offset within the SGCN buffer of the input buffer end */
+	uint32_t in_end;
+	
+	/** offset within the SGCN buffer of the input buffer read pointer */
+	uint32_t in_rdptr;
+	
+	/** offset within the SGCN buffer of the input buffer write pointer */
+	uint32_t in_wrptr;
+} __attribute__ ((packed)) sgcn_buffer_header_t;
+
+/*
+ * Returns a pointer to the object of a given type which is placed at the given
+ * offset from the console buffer beginning.
+ */
+#define SGCN_BUFFER(type, offset) \
+		((type *) (sram_virt_addr + sram_buffer_offset + (offset)))
+
+/** Returns a pointer to the console buffer header. */
+#define SGCN_BUFFER_HEADER	(SGCN_BUFFER(sgcn_buffer_header_t, 0))
+
+/**
+ * Virtual address mapped to SRAM.
+ */
+static uintptr_t sram_virt_addr;
+
+/**
+ * SGCN buffer offset within SGCN.
+ */
+static uintptr_t sram_buffer_offset;
+
+/* polling thread */
+static void sgcn_thread_impl(void *arg);
+
+static volatile bool polling_disabled = false;
+
+/**
+ * Initializes the SGCN driver.
+ * Maps the physical memory (SRAM) and creates the polling thread. 
+ */
+int kbd_port_init(void)
+{
+	sysarg_t sram_paddr;
+	if (sysinfo_get_value("sram.address.physical", &sram_paddr) != EOK)
+		return -1;
+	
+	sysarg_t sram_size;
+	if (sysinfo_get_value("sram.area.size", &sram_size) != EOK)
+		return -1;
+	
+	if (sysinfo_get_value("sram.buffer.offset", &sram_buffer_offset) != EOK)
+		sram_buffer_offset = 0;
+	
+	sram_virt_addr = (uintptr_t) as_get_mappable_page(sram_size);
+	
+	if (physmem_map((void *) sram_paddr, (void *) sram_virt_addr,
+	    sram_size / PAGE_SIZE, AS_AREA_READ | AS_AREA_WRITE) != 0) {
+		printf("SGCN: uspace driver could not map physical memory.");
+		return -1;
+	}
+	
+	thread_id_t tid;
+	int rc = thread_create(sgcn_thread_impl, NULL, "kbd_poll", &tid);
+	if (rc != 0)
+		return rc;
+	
+	return 0;
+}
+
+void kbd_port_yield(void)
+{
+	polling_disabled = true;
+}
+
+void kbd_port_reclaim(void)
+{
+	polling_disabled = false;
+}
+
+void kbd_port_write(uint8_t data)
+{
+	(void) data;
+}
+
+/**
+ * Handler of the "key pressed" event. Reads codes of all the pressed keys from
+ * the buffer. 
+ */
+static void sgcn_key_pressed(void)
+{
+	char c;
+	
+	uint32_t begin = SGCN_BUFFER_HEADER->in_begin;
+	uint32_t end = SGCN_BUFFER_HEADER->in_end;
+	uint32_t size = end - begin;
+	
+	volatile char *buf_ptr = (volatile char *)
+		SGCN_BUFFER(char, SGCN_BUFFER_HEADER->in_rdptr);
+	volatile uint32_t *in_wrptr_ptr = &(SGCN_BUFFER_HEADER->in_wrptr);
+	volatile uint32_t *in_rdptr_ptr = &(SGCN_BUFFER_HEADER->in_rdptr);
+	
+	while (*in_rdptr_ptr != *in_wrptr_ptr) {
+		c = *buf_ptr;
+		*in_rdptr_ptr = (((*in_rdptr_ptr) - begin + 1) % size) + begin;
+		buf_ptr = (volatile char *)
+			SGCN_BUFFER(char, SGCN_BUFFER_HEADER->in_rdptr);
+		kbd_push_scancode(c);
+	}
+}
+
+/**
+ * Thread to poll SGCN for keypresses.
+ */
+static void sgcn_thread_impl(void *arg)
+{
+	(void) arg;
+
+	while (1) {
+		if (polling_disabled == false)
+			sgcn_key_pressed();
+		usleep(POLL_INTERVAL);
+	}
+}
+
+/** @}
+ */
Index: uspace/srv/hid/input/port/sun.c
===================================================================
--- uspace/srv/hid/input/port/sun.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
+++ uspace/srv/hid/input/port/sun.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2009 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_port
+ * @ingroup  kbd
+ * @{
+ */
+/** @file
+ * @brief Sun keyboard virtual port driver.
+ */
+
+#include <kbd.h>
+#include <kbd_port.h>
+#include <sun.h>
+#include <sysinfo.h>
+#include <errno.h>
+#include <bool.h>
+
+/** Sun keyboard virtual port driver.
+ *
+ * This is a virtual port driver which can use
+ * both ns16550_port_init and z8530_port_init
+ * according to the information passed from the
+ * kernel. This is just a temporal hack.
+ *
+ */
+int kbd_port_init(void)
+{
+	sysarg_t z8530;
+	if (sysinfo_get_value("kbd.type.z8530", &z8530) != EOK)
+		z8530 = false;
+	
+	sysarg_t ns16550;
+	if (sysinfo_get_value("kbd.type.ns16550", &ns16550) != EOK)
+		ns16550 = false;
+	
+	if (z8530) {
+		if (z8530_port_init() == 0)
+			return 0;
+	}
+	
+	if (ns16550) {
+		if (ns16550_port_init() == 0)
+			return 0;
+	}
+	
+	return -1;
+}
+
+void kbd_port_yield(void)
+{
+}
+
+void kbd_port_reclaim(void)
+{
+}
+
+void kbd_port_write(uint8_t data)
+{
+	(void) data;
+}
+
+/** @}
+*/
Index: uspace/srv/hid/input/port/z8530.c
===================================================================
--- uspace/srv/hid/input/port/z8530.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
+++ uspace/srv/hid/input/port/z8530.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -0,0 +1,116 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_port
+ * @ingroup  kbd
+ * @{
+ */
+/** @file
+ * @brief Z8530 keyboard port driver.
+ */
+
+#include <ipc/irc.h>
+#include <async.h>
+#include <sysinfo.h>
+#include <kbd.h>
+#include <kbd_port.h>
+#include <sun.h>
+#include <sys/types.h>
+#include <ddi.h>
+#include <errno.h>
+
+#define CHAN_A_STATUS  4
+#define CHAN_A_DATA    6
+
+#define RR0_RCA  1
+
+static irq_cmd_t z8530_cmds[] = {
+	{
+		.cmd = CMD_PIO_READ_8,
+		.addr = (void *) 0,     /* Will be patched in run-time */
+		.dstarg = 1
+	},
+	{
+		.cmd = CMD_BTEST,
+		.value = RR0_RCA,
+		.srcarg = 1,
+		.dstarg = 3
+	},
+	{
+		.cmd = CMD_PREDICATE,
+		.value = 2,
+		.srcarg = 3
+	},
+	{
+		.cmd = CMD_PIO_READ_8,
+		.addr = (void *) 0,     /* Will be patched in run-time */
+		.dstarg = 2
+	},
+	{
+		.cmd = CMD_ACCEPT
+	}
+};
+	
+irq_code_t z8530_kbd = {
+	sizeof(z8530_cmds) / sizeof(irq_cmd_t),
+	z8530_cmds
+};
+
+static void z8530_irq_handler(ipc_callid_t iid, ipc_call_t *call);
+
+int z8530_port_init(void)
+{
+	sysarg_t kaddr;
+	if (sysinfo_get_value("kbd.address.kernel", &kaddr) != EOK)
+		return -1;
+	
+	sysarg_t inr;
+	if (sysinfo_get_value("kbd.inr", &inr) != EOK)
+		return -1;
+	
+	z8530_cmds[0].addr = (void *) kaddr + CHAN_A_STATUS;
+	z8530_cmds[3].addr = (void *) kaddr + CHAN_A_DATA;
+	
+	async_set_interrupt_received(z8530_irq_handler);
+	register_irq(inr, device_assign_devno(), inr, &z8530_kbd);
+	
+	return 0;
+}
+
+static void z8530_irq_handler(ipc_callid_t iid, ipc_call_t *call)
+{
+	int scan_code = IPC_GET_ARG2(*call);
+	kbd_push_scancode(scan_code);
+	
+	if (irc_service)
+		async_msg_1(irc_phone, IRC_CLEAR_INTERRUPT,
+		    IPC_GET_IMETHOD(*call));
+}
+
+/** @}
+ */
Index: uspace/srv/loc/loc.c
===================================================================
--- uspace/srv/loc/loc.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/loc/loc.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -56,10 +56,4 @@
 #define NULL_SERVICES  256
 
-/** Callback session */
-typedef struct {
-	link_t cb_sess_list;
-	async_sess_t *sess;
-} cb_sess_t;
-
 LIST_INITIALIZE(services_list);
 LIST_INITIALIZE(namespaces_list);
@@ -92,5 +86,5 @@
 
 static FIBRIL_MUTEX_INITIALIZE(callback_sess_mutex);
-static LIST_INITIALIZE(callback_sess_list);
+static async_sess_t *callback_sess = NULL;
 
 service_id_t loc_create_id(void)
@@ -614,5 +608,4 @@
 	size_t act_size;
 	loc_service_t *svc;
-	char *fqn;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -632,14 +625,6 @@
 	}
 	
-	if (asprintf(&fqn, "%s/%s", svc->namespace->name, svc->name) < 0) {
-		fibril_mutex_unlock(&services_list_mutex);
-		async_answer_0(callid, ENOMEM);
-		async_answer_0(iid, ENOMEM);
-		return;
-	}
-	
-	act_size = str_size(fqn);
+	act_size = str_size(svc->name);
 	if (act_size > size) {
-		free(fqn);
 		fibril_mutex_unlock(&services_list_mutex);
 		async_answer_0(callid, EOVERFLOW);
@@ -648,7 +633,6 @@
 	}
 	
-	sysarg_t retval = async_data_read_finalize(callid, fqn,
+	sysarg_t retval = async_data_read_finalize(callid, svc->name,
 	    min(size, act_size));
-	free(fqn);
 	
 	fibril_mutex_unlock(&services_list_mutex);
@@ -806,10 +790,7 @@
 }
 
-/** Create callback connection.
- *
- * Create callback connection which will be used to send category change
- * events.
- *
- * On success, answer will contain EOK int retval.
+/** Find ID for category specified by name.
+ *
+ * On success, answer will contain EOK int retval and service ID in arg1.
  * On failure, error code will be sent in retval.
  *
@@ -817,5 +798,5 @@
 static void loc_callback_create(ipc_callid_t iid, ipc_call_t *icall)
 {
-	cb_sess_t *cb_sess = calloc(1, sizeof(cb_sess_t));
+	async_sess_t *cb_sess = async_callback_receive(EXCHANGE_SERIALIZE);
 	if (cb_sess == NULL) {
 		async_answer_0(iid, ENOMEM);
@@ -823,16 +804,12 @@
 	}
 	
-	async_sess_t *sess = async_callback_receive(EXCHANGE_SERIALIZE);
-	if (sess == NULL) {
-		free(cb_sess);
-		async_answer_0(iid, ENOMEM);
-		return;
-	}
-	
-	cb_sess->sess = sess;
-	link_initialize(&cb_sess->cb_sess_list);
-	
 	fibril_mutex_lock(&callback_sess_mutex);
-	list_append(&cb_sess->cb_sess_list, &callback_sess_list);
+	if (callback_sess != NULL) {
+		fibril_mutex_unlock(&callback_sess_mutex);
+		async_answer_0(iid, EEXIST);
+		return;
+	}
+	
+	callback_sess = cb_sess;
 	fibril_mutex_unlock(&callback_sess_mutex);
 	
@@ -843,15 +820,11 @@
 {
 	fibril_mutex_lock(&callback_sess_mutex);
-	
-	list_foreach(callback_sess_list, link) {
-		cb_sess_t *cb_sess;
-		
-		cb_sess = list_get_instance(link, cb_sess_t, cb_sess_list);
-		
-		async_exch_t *exch = async_exchange_begin(cb_sess->sess);
+
+	if (callback_sess != NULL) {
+		async_exch_t *exch = async_exchange_begin(callback_sess);
 		async_msg_0(exch, LOC_EVENT_CAT_CHANGE);
 		async_exchange_end(exch);
 	}
-	
+
 	fibril_mutex_unlock(&callback_sess_mutex);
 }
Index: uspace/srv/net/cfg/e1k.nic
===================================================================
--- uspace/srv/net/cfg/e1k.nic	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/cfg/e1k.nic	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -3,5 +3,5 @@
 NAME=e1k
 
-HWPATH=devices/\hw\pci0\00:03.0\port0
+HWPATH=/hw/pci0/00:03.0/port0
 NIL=eth
 IL=ip
Index: uspace/srv/net/cfg/lo.nic
===================================================================
--- uspace/srv/net/cfg/lo.nic	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/cfg/lo.nic	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -3,5 +3,5 @@
 NAME=lo
 
-HWPATH=devices/\virt\lo\port0
+HWPATH=/virt/lo/port0
 NIL=nildummy
 IL=ip
Index: uspace/srv/net/cfg/ne2k.nic
===================================================================
--- uspace/srv/net/cfg/ne2k.nic	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/cfg/ne2k.nic	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -3,5 +3,5 @@
 NAME=ne2k
 
-HWPATH=devices/\hw\pci0\00:01.0\ne2k\port0
+HWPATH=/hw/pci0/00:01.0/ne2k/port0
 NIL=eth
 IL=ip
Index: uspace/srv/net/net/Makefile
===================================================================
--- uspace/srv/net/net/Makefile	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/net/Makefile	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -31,6 +31,5 @@
 ROOT_PATH = $(USPACE_PREFIX)/..
 LIBS = $(LIBNET_PREFIX)/libnet.a
-EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include \
-    -I$(LIBDRV_PREFIX)/include
+EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include
 
 COMMON_MAKEFILE = $(ROOT_PATH)/Makefile.common
Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/net/net.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -2,5 +2,4 @@
  * Copyright (c) 2009 Lukas Mejdrech
  * Copyright (c) 2011 Radim Vansa
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,4 +41,5 @@
 #include <stdio.h>
 #include <str.h>
+#include <devman.h>
 #include <str_error.h>
 #include <ns.h>
@@ -56,7 +56,4 @@
 #include <adt/measured_strings.h>
 #include <adt/module_map.h>
-#include <fibril_synch.h>
-#include <loc.h>
-#include <nic.h>
 #include <nil_remote.h>
 #include <net_interface.h>
@@ -76,7 +73,4 @@
 GENERIC_CHAR_MAP_IMPLEMENT(measured_strings, measured_string_t);
 DEVICE_MAP_IMPLEMENT(netifs, netif_t);
-LIST_INITIALIZE(netif_list);
-
-static FIBRIL_MUTEX_INITIALIZE(discovery_lock);
 
 /** Add the configured setting to the configuration map.
@@ -293,10 +287,10 @@
  *
  */
-static int init_device(netif_t *netif, service_id_t sid)
+static int init_device(netif_t *netif, devman_handle_t handle)
 {
 	printf("%s: Initializing device '%s'\n", NAME, netif->name);
 	
-	netif->sid = sid;
-	netif->sess = loc_service_connect(EXCHANGE_SERIALIZE, netif->sid,
+	netif->handle = handle;
+	netif->sess = devman_device_connect(EXCHANGE_SERIALIZE, netif->handle,
 	    IPC_FLAG_BLOCKING);
 	if (netif->sess == NULL) {
@@ -343,5 +337,5 @@
 		    strtol((const char *) setting->value, NULL, 10) : 0;
 		rc = nil_device_req(netif->nil->sess, netif->id,
-		    netif->sid, mtu);
+		    netif->handle, mtu);
 		if (rc != EOK) {
 			printf("%s: Unable to start network interface layer\n",
@@ -365,35 +359,22 @@
 		break;
 	default:
-		printf("%s: Unknown service\n", NAME);
 		return ENOENT;
 	}
 	
 	printf("%s: Activating device '%s'\n", NAME, netif->name);
-	list_append(&netif->netif_list, &netif_list);
 	return nic_set_state(netif->sess, NIC_STATE_ACTIVE);
 }
 
-static int net_nic_ready(service_id_t sid)
-{
-	int rc;
-	char *hwpath;
-	
-	rc = loc_service_get_name(sid, &hwpath);
-	if (rc != EOK) {
-		printf("%s: Failed getting name of service '%u'\n",
-		    NAME, (unsigned) sid);
+static int net_port_ready(devman_handle_t handle)
+{
+	char hwpath[MAX_PATH_LENGTH];
+	int rc = devman_fun_get_path(handle, hwpath, MAX_PATH_LENGTH);
+	if (rc != EOK)
 		return EINVAL;
-	}
 	
 	int index = char_map_find(&net_globals.netif_hwpaths,
 	    (uint8_t *) hwpath, 0);
-	
-	if (index == CHAR_MAP_NULL) {
-		printf("%s: Service '%s' not found in map.\n", NAME, hwpath);
-		free(hwpath);
+	if (index == CHAR_MAP_NULL)
 		return ENOENT;
-	}
-	
-	free(hwpath);
 	
 	netif_t *netif = netifs_get_index(&net_globals.netifs, index);
@@ -401,5 +382,5 @@
 		return ENOENT;
 	
-	rc = init_device(netif, sid);
+	rc = init_device(netif, handle);
 	if (rc != EOK)
 		return rc;
@@ -410,4 +391,21 @@
 	
 	netif->il->usage++;
+	
+	return EOK;
+}
+
+static int net_driver_ready_local(devman_handle_t handle)
+{
+	devman_handle_t *funs;
+	size_t count;
+	int rc = devman_dev_get_functions(handle, &funs, &count);
+	if (rc != EOK)
+		return rc;
+	
+	for (size_t i = 0; i < count; i++) {
+		rc = net_port_ready(funs[i]);
+		if (rc != EOK)
+			return rc;
+	}
 	
 	return EOK;
@@ -481,4 +479,8 @@
 		net_free_devices(strings, count);
 		return rc;
+	case NET_NET_DRIVER_READY:
+		rc = net_driver_ready_local(IPC_GET_ARG1(*call));
+		*answer_count = 0;
+		return rc;
 	default:
 		return ENOTSUP;
@@ -526,71 +528,4 @@
 		answer_call(callid, res, &answer, count);
 	}
-}
-
-static int nic_check_new(void)
-{
-	category_id_t nic_cat;
-	service_id_t *svcs;
-	size_t count, i;
-	bool already_known;
-	int rc;
-
-	fibril_mutex_lock(&discovery_lock);
-
-	rc = loc_category_get_id(DEVICE_CATEGORY_NIC, &nic_cat, IPC_FLAG_BLOCKING);
-	if (rc != EOK) {
-		printf("%s: Failed resolving category '%s'.\n", NAME,
-		    DEVICE_CATEGORY_NIC);
-		return ENOENT;
-	}
-
-	rc = loc_category_get_svcs(nic_cat, &svcs, &count);
-	if (rc != EOK) {
-		printf("%s: Failed getting list of NIC devices.\n", NAME);
-		return EIO;
-	}
-
-	for (i = 0; i < count; i++) {
-		already_known = false;
-
-		list_foreach(netif_list, link) {
-			netif_t *netif = list_get_instance(link, netif_t, netif_list);
-			if (netif->sid == svcs[i]) {
-				already_known = true;
-				break;
-			}
-		}
-
-		if (!already_known) {
-			rc = net_nic_ready(svcs[i]);
-			if (rc != EOK) {
-				printf("%s: Failed adding NIC device #%u.\n",
-				    NAME, (unsigned) svcs[i]);
-			}
-		}
-	}
-
-	free(svcs);
-	fibril_mutex_unlock(&discovery_lock);
-	return EOK;
-}
-
-static void cat_change_cb(void)
-{
-	(void) nic_check_new();
-}
-
-static int net_start_nic_discovery(void)
-{
-	int rc;
-
-	rc = loc_register_cat_change_cb(cat_change_cb);
-	if (rc != EOK) {
-		printf("%s: Failed registering callback for device discovery (%d).\n",
-		    NAME, rc);
-		return rc;
-	}
-
-	return nic_check_new();
 }
 
@@ -638,5 +573,5 @@
 				continue;
 			
-			netif->sid = -1;
+			netif->handle = -1;
 			netif->sess = NULL;
 			
@@ -762,11 +697,4 @@
 	}
 	
-	rc = net_start_nic_discovery();
-	if (rc != EOK) {
-		printf("%s: Error starting NIC discovery\n", NAME);
-		pm_destroy();
-		return rc;
-	}
-	
 	task_retval(0);
 	async_manager();
Index: uspace/srv/net/net/net.h
===================================================================
--- uspace/srv/net/net/net.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/srv/net/net/net.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -35,5 +35,4 @@
 #define NET_NET_H_
 
-#include <ipc/loc.h>
 #include <net/device.h>
 #include <adt/char_map.h>
@@ -42,4 +41,5 @@
 #include <adt/module_map.h>
 #include <net/packet.h>
+#include <devman.h>
 
 #define NAME  "net"
@@ -96,11 +96,9 @@
 	
 	/** Serving network interface driver module index. */
-	service_id_t sid;    /**< Service ID */
-	async_sess_t *sess;  /**< Driver session. */
+	devman_handle_t handle;  /**< Handle for devman */
+	async_sess_t *sess;      /**< Driver session. */
 	
 	module_t *nil;  /**< Serving link layer module index. */
 	module_t *il;   /**< Serving internet layer module index. */
-	
-	link_t netif_list;
 } netif_t;
 
